uuagc

Options

Synopsis

- data Identifier = Ident {
  - getName :: String
  - getPos :: Pos
  }
- type NontermIdent = Identifier
- data MyOptDescr = MyOpt [Char] [String] (ArgDescr (Options -> Options)) (Options -> String -> [String]) String
- fromMyOpt :: MyOptDescr -> OptDescr (Options -> Options)
- noOpt :: Options -> String -> [String]
- boolOpt :: (Options -> Bool) -> Options -> String -> [String]
- stringOpt :: (Options -> String) -> Options -> String -> [String]
- mbStringOpt :: (Options -> Maybe String) -> Options -> String -> [String]
- serializeOption :: Options -> MyOptDescr -> [String]
- allOptions :: [MyOptDescr]
- options :: [OptDescr (Options -> Options)]
- data ModuleHeader
  - = NoName
  - | Name String
  - | Default
- data Options = Options {
  - moduleName :: ModuleHeader
  - dataTypes :: Bool
  - dataRecords :: Bool
  - strictData :: Bool
  - strictWrap :: Bool
  - folds :: Bool
  - semfuns :: Bool
  - typeSigs :: Bool
  - attrInfo :: Bool
  - rename :: Bool
  - wrappers :: Bool
  - modcopy :: Bool
  - newtypes :: Bool
  - nest :: Bool
  - smacro :: Bool
  - outputFiles :: [String]
  - searchPath :: [String]
  - verbose :: Bool
  - prefix :: String
  - withSelf :: Bool
  - withCycle :: Bool
  - showHelp :: Bool
  - showVersion :: Bool
  - visit :: Bool
  - withSeq :: Bool
  - unbox :: Bool
  - bangpats :: Bool
  - cases :: Bool
  - strictCases :: Bool
  - stricterCases :: Bool
  - strictSems :: Bool
  - localCps :: Bool
  - splitSems :: Bool
  - werrors :: Bool
  - wignore :: Bool
  - wmaxerrs :: Int
  - dumpgrammar :: Bool
  - dumpcgrammar :: Bool
  - sepSemMods :: Bool
  - genFileDeps :: Bool
  - genLinePragmas :: Bool
  - genvisage :: Bool
  - genAspectAG :: Bool
  - noGroup :: [String]
  - extends :: Maybe String
  - genAttributeList :: Bool
  - forceIrrefutables :: Maybe String
  - uniqueDispenser :: String
  - lcKeywords :: Bool
  - doubleColons :: Bool
  - monadic :: Bool
  - ocaml :: Bool
  - visitorsOutput :: Bool
  - statsFile :: Maybe String
  - breadthFirst :: Bool
  - breadthFirstStrict :: Bool
  - checkParseRhs :: Bool
  - checkParseTy :: Bool
  - checkParseBlock :: Bool
  - nocatas :: Set NontermIdent
  - noOptimizations :: Bool
  - reference :: Bool
  - kennedyWarren :: Bool
  - parallelInvoke :: Bool
  - tupleAsDummyToken :: Bool
  - dummyTokenVisit :: Bool
  - strictDummyToken :: Bool
  - noPerRuleTypeSigs :: Bool
  - noPerStateTypeSigs :: Bool
  - noEagerBlackholing :: Bool
  - lateHigherOrderBinding :: Bool
  - monadicWrappers :: Bool
  - genTraces :: Bool
  - genUseTraces :: Bool
  - genCostCentres :: Bool
  - noPerRuleCostCentres :: Bool
  - noPerVisitCostCentres :: Bool
  - helpInlining :: Bool
  - noInlinePragmas :: Bool
  - aggressiveInlinePragmas :: Bool
  }
- constructOptions :: [Options -> Options] -> Options
- getOptions :: [String] -> (Options, [String], [String])
- optionsToString :: Options -> [String]
- combineOptions :: Options -> Options -> Options

# Documentation

data Identifier

Constructors

Ident |
Fields getName :: String getPos :: Pos

Instances

Eq Identifier |
Ord Identifier |
Show Identifier |
PP Identifier |

type NontermIdent = Identifier

data MyOptDescr

Constructors

MyOpt [Char] [String] (ArgDescr (Options -> Options)) (Options -> String -> [String]) String |

fromMyOpt :: MyOptDescr -> OptDescr (Options -> Options)

noOpt :: Options -> String -> [String]

boolOpt :: (Options -> Bool) -> Options -> String -> [String]

stringOpt :: (Options -> String) -> Options -> String -> [String]

mbStringOpt :: (Options -> Maybe String) -> Options -> String -> [String]

serializeOption :: Options -> MyOptDescr -> [String]

allOptions :: [MyOptDescr]

options :: [OptDescr (Options -> Options)]

data ModuleHeader

Constructors

NoName |
Name String |
Default |

Instances

Eq ModuleHeader |
Show ModuleHeader |

data Options

Constructors

Options |
Fields moduleName :: ModuleHeader dataTypes :: Bool dataRecords :: Bool strictData :: Bool strictWrap :: Bool folds :: Bool semfuns :: Bool typeSigs :: Bool attrInfo :: Bool rename :: Bool wrappers :: Bool modcopy :: Bool newtypes :: Bool nest :: Bool smacro :: Bool outputFiles :: [String] searchPath :: [String] verbose :: Bool prefix :: String withSelf :: Bool withCycle :: Bool showHelp :: Bool showVersion :: Bool visit :: Bool withSeq :: Bool unbox :: Bool bangpats :: Bool cases :: Bool strictCases :: Bool stricterCases :: Bool strictSems :: Bool localCps :: Bool splitSems :: Bool werrors :: Bool wignore :: Bool wmaxerrs :: Int dumpgrammar :: Bool dumpcgrammar :: Bool sepSemMods :: Bool genFileDeps :: Bool genLinePragmas :: Bool genvisage :: Bool genAspectAG :: Bool noGroup :: [String] extends :: Maybe String genAttributeList :: Bool forceIrrefutables :: Maybe String uniqueDispenser :: String lcKeywords :: Bool doubleColons :: Bool monadic :: Bool ocaml :: Bool visitorsOutput :: Bool statsFile :: Maybe String breadthFirst :: Bool breadthFirstStrict :: Bool checkParseRhs :: Bool checkParseTy :: Bool checkParseBlock :: Bool nocatas :: Set NontermIdent noOptimizations :: Bool reference :: Bool kennedyWarren :: Bool parallelInvoke :: Bool tupleAsDummyToken :: Bool dummyTokenVisit :: Bool strictDummyToken :: Bool noPerRuleTypeSigs :: Bool noPerStateTypeSigs :: Bool noEagerBlackholing :: Bool lateHigherOrderBinding :: Bool monadicWrappers :: Bool genTraces :: Bool genUseTraces :: Bool genCostCentres :: Bool noPerRuleCostCentres :: Bool noPerVisitCostCentres :: Bool helpInlining :: Bool noInlinePragmas :: Bool aggressiveInlinePragmas :: Bool

Instances

Eq Options |
Show Options |

constructOptions :: [Options -> Options] -> Options

Use all parsed options to generate real options

getOptions :: [String] -> (Options, [String], [String])

Create Options type from string arguments

optionsToString :: Options -> [String]

Convert options back to commandline string

combineOptions :: Options -> Options -> Options

Combine 2 sets of options